function [newx,newy,newh]=bigbord(x,y,h);
% function [newx,newy,newh]=bigbord(x,y,h);
% Add a border out to a power of 2
% adapted to output indices of input data within expanded grid

[m,n]=size(h);

%Find mean of perimeter values
pmean=(sum(h(1,:)+h(m,:)) + sum(h(2:m-1,1)+h(2:m-1,n)))/(2*m+2*n-2);
mm=max([m n]);
mm=2.0 ^ceil(log2(max([m n])));
% fprintf('New square array dimension %d\n',mm);
newh=pmean*ones (mm);
m1=floor((mm-m)/2);
m2=m1+m-1;
n1=floor((mm-n)/2);
n2=n1+n-1;
% fprintf('Old array now on indices: %g - %g, %g - %g\n',m1,m2,n1,n2)

dx = abs(x(2)-x(1));
newx(n1:n2) = x;
newx(1:n1-1) = (x(1)-([n1-1:-1:1].*dx)); 
newx(n2+1:mm) = (x(end)+([1:mm-n2].*dx));

newy(m1:m2) = y; 
newy(1:m1-1) = (y(1)-([m1-1:-1:1].*dx));
newy(m2+1:mm) = (y(end)+([1:mm-m2].*dx));

newh(m1:m2, n1:n2)=h;
% Linearly interpolate in the border
for i=2:n1-1
  alpha=(i-1)/(n1-1);
  newh(:,i)=(1-alpha)*newh(:,1) + alpha*newh(:,n1);
end

for i=n2+1:mm-1
  alpha=(i-n2)/(mm-n2);
  newh(:,i)=(1-alpha)*newh(:,n2) + alpha*newh(:,mm);
end

for i=2:m1-1
  alpha=(i-1)/(m1-1);
  newh(i,:)=(1-alpha)*newh(1,:) + alpha*newh(m1,:);
end

for i=m2+1:mm-1
  alpha=(i-m2)/(mm-m2);
  newh(i,:)=(1-alpha)*newh(m2,:) + alpha*newh(mm,:);
end

m=mm;

%newh

%-----------------------------------------------------------

