function [kx,ky,sp] = grdfft(xf,yf,tf)

if length(xf)>1
    dx = abs(xf(2)-xf(1));
else
    dx=xf;
end
if length(yf)>1
    dy = abs(yf(2)-yf(1));
else
    dy=yf;
end

sp = fft2 (tf) ; 
sp = fftshift (sp) ; 

%% First, need to get the frequency scale right.
%% Remember, for even number of points in spectrum, central frequency 
%% is not right at the centre, hence frequency spacing is given as follows
kxmax = ((2*pi)/(dx*2));
kymax = ((2*pi)/(dy*2));
kxinc = kxmax./((size(tf,2)/2));
kyinc = kymax./((size(tf,1)/2));

%% make grid of correctly scaled frequencies
[kx,ky] = meshgrid (-kxmax:kxinc:(kxmax-kxinc), -kymax:kyinc:(kymax-kyinc)) ;


