function [tmask] = grdmask (x,y,t,xf,yf,tf);
% [tmask] = grdmask (x,y,t,xf,yf,tf);
%   Trim and mask the filled grid defined by xf,yf,tf to only cover the area defined 
%   by the (presumably original) grid x,y,t 
%   NB ASSUMES SAME CELL SIZE FOR BOTH GRIDS

x0 = find(abs((x(1)-xf))==min(abs(x(1)-xf)));
y0 = find(abs((y(1)-yf))==min(abs(y(1)-yf)));

tmask = tf(y0:y0+length(y)-1,x0:x0+length(x)-1);
tmask(isnan(t)) = nan;


