function out = han3(in,npass)
% HAN3
%   gfilt = han3 (g,npass)
%   hanning filters a grid

if nargin<2
    npass = 1;
end

for num = 1:npass
    [m,n] = size(in);
    i = [1:m-2];
    j = [1:n-2];
    han = zeros(m-2,n-2);
    han(i,j) = (in(i,j) + in(i+1,j) + in(i+2,j) ...
        + in(i,j+1) + in(i+1,j+1)*2 + in(i+2,j+1) ...
        + in(i,j+2) + in(i+1,j+2) + in(i+2,j+2))./10;

    out=zeros(m,n);
    out(i+1,j+1) = han(i,j);
    out(2:m-1,1) = han(:,2);
    out(2:m-1,n) = han(:,n-2);
    out(1,2:n-1) = han(2,:);
    out(m,2:n-1) = han(m-2,:);
    out(1,1) = mean([out(1,2),out(2,1)]);
    out(1,n) = mean([out(1,n-1),out(2,n)]);
    out(m,1) = mean([out(m,2),out(m-1,1)]);
    out(m,n) = mean([out(m,n-1),out(m-1,n)]);
    
    in=out;
end