function [Zinv] = oldenburg(x,y,grv,deltaRho,Zref);
% [Zinv] = oldenburg(x,y,grv,deltaRho,Zref);
%  NB. The input parameters MUST be in km

% Zref = 5;              % Reference Depth (km)
ConvCrit = 0.02;    % convergence criteria


[xf,yf,grvf] = bigbord(x,y,grv);


%% only do this to get spectrum scale
[kx,ky,GrvSpec] = grdfft (xf,yf,grvf);



%% calculate Cm, Thetam, Thetaf, M
Gamma = 6.67e-11;
si2mg = 1e5;
km2m=1e3;
Gamma = Gamma*si2mg*km2m;


k = sqrt(kx.^2+ky.^2);

% Constant Term
Const = (GrvSpec.*exp(-k.*Zref))./(2*pi*Gamma*deltaRho);

% Initial estimate of Z surface derived from constant term
% NEED FILTERING HERE??
Z = real(ifft2(ifftshift(Const)));

% Taylor Series Expansion for summation term
numtaylor = 1;
tol = 8;
NthSum = zeros(size(grvf));

while numtaylor<=tol
    NthTerm = ((k.^(numtaylor-1))./factorial(numtaylor)) .* (fftshift(fft2(Z)));
    
    NthSum = Const - NthTerm;
    
    Z = real(ifft2(ifftshift(NthSum)));
    
%     disp(['finished iteration ',num2str(numtaylor),' ....'])
    numtaylor = numtaylor+1;
    
end

Z = grdmask(x,y,grv,xf,yf,Z); 

Zinv = (Z./km2m)+Zref;



