% function [t] = parkergrav(x,y,z1,z2,M);
% % [t] = parkergrav(x,y,z1,z2,RHO);
% %   Synthetic gravity response response for layer bounded by surfaces z1 and z2
% %   z positive downwards
% %   see Blakely, p294
% %
% % NB units MUST be kilometres and Kg/m3 (1000 greater than g/cc)
% %
% 
% 
% % for fast convergence, z0 is set to be midway between minimum 
% % values of z1 and z2. Could cause problems for very thick layers
% % z0 = (min(z2(~isnan(z2)))+min(z1(~isnan(z1))))/2;
% z0 = (max(z1(~isnan(z1)))+min(z1(~isnan(z1))))/2;
% % z0 = mean(mean(z1));
% z1 = z1-z0;
% z2 = z2-z0;
% % z0 = z0-z0;
% % z0 = 0;
% disp(['z0 set to ',num2str(z0)])
% 
% % [xf,yf,z1f] = gridfill_new(x,y,z1);
% [xf,yf,z1f] = bigbord(x,y,z1);
% z2f = ones(size(z1f)).*z2;
% % [xf,yf,z2f] = gridfill_new(x,y,z2);
% % [kx,ky,Z1sp] = grdfft (x,y,z1f);
% % [kx,ky,Z2sp] = grdfft (x,y,z2f);
% 
% % [xf,yf,zf] = gridfill_new(x,y,z);
% 
% 
% %% only do this to get spectrum scale
% [kx,ky,dummy] = grdfft (x,y,z1f);
% 
% 
% %% calculate Cm, Thetam, Thetaf, M
% Gamma = 6.67e-11;
% si2mg = 1e5;
% km2m=1e3;
% Gamma = Gamma*si2mg*km2m;
% %% This M could be a grid of varying magnetization
% if length(M)~=1
%     [xf,yf,M] = bigbord(x,y,M);
% end
% % M = ones(size(z1f)).*M;
% % M = fftshift(fft2(M));
% 
% k = sqrt(kx.^2+ky.^2);
% % note next term includes an upward continuation from z0 to z=0;
% % Blakely (p294) doesn't have a minus sign here, but need it if convention
% % is positive downwards
% Const = 2*pi*Gamma.*exp(-k.*z0);
% 
% 
% numtaylor = 1;
% tol = 8;
% NthSum = zeros(size(z1f));
% 
% while numtaylor<=tol
%     
%     %% Note that the term on the next line gets much bigger with each iteration,
%     %% leading to instabilities if the number of iterations is too large +
%     %% if topography is severe
% %     zf = ((z1f.^numtaylor) - (z2f.^numtaylor)).*M;
%     zf = (z1f.^numtaylor).*M;
% %     [xf,yf,zf] = gridfill_new(x,y,z);
%     [kx,ky,Zsp] = grdfft (x,y,zf);
%     Nthterm = (((-k).^(numtaylor-1))./factorial(numtaylor)) .* (Zsp);
%     
%    
%     NthSum = NthSum + (Const.*Nthterm);
%     
%     disp(['finished iteration ',num2str(numtaylor),' ....'])
%     numtaylor = numtaylor+1;
%     
% end
% 
% 
% t = real(ifft2(ifftshift(NthSum)));
% t = grdmask(x,y,z1,xf,yf,t);
% 
%     
%     
%     
function [t] = parkergrav(x,y,z1,z2,M);
% x = [10:200:1000];
% y = [10:200:2000];
% z1 = ones(10,5);
% z2 = ones(10,5)*3;
% M = ones(10,5)*2000;
% M(5,3) = 3000;
% z1(1,5) = 1.50;
% z1(10,5) = 10.50;
% z1(10,1) = 10.1;
% z1(1,1) = 1.1;



% tt = [40:40:160];
% w = fft(tt);
% [t] = parkergrav(x,y,z1,z2,RHO);
%   Synthetic gravity response response for layer bounded by surfaces z1 and z2
%   z positive downwards
%   see Blakely, p294
%
% NB units MUST be kilometres and Kg/m3 (1000 greater than g/cc)
%

%% Z
% for fast convergence, z0 is set to be midway between minimum 
% values of z1 and z2. Could cause problems for very thick layers
% z0 = (min(z2(~isnan(z2)))+min(z1(~isnan(z1))))/2;
z0 = (max(z2(~isnan(z2)))+min(z1(~isnan(z1))))/2;
% z0 = mean(mean(z1));
z1 = z1-z0;
z2 = z2-z0;
% z0 = z0-z0;
% z0 = 0;
% disp(['z0 set to ',num2str(z0)])

%% Extent
% [xf,yf,z1f] = gridfill_new(x,y,z1);
[xf,yf,z1f] = bigbord(x,y,z1);
[xf,yf,z2f] = bigbord(x,y,z2);
% z2f = ones(size(z1f)).*z2;
% [xf,yf,z2f] = gridfill_new(x,y,z2);
% [kx,ky,Z1sp] = grdfft (x,y,z1f);
% [kx,ky,Z2sp] = grdfft (x,y,z2f);

% [xf,yf,zf] = gridfill_new(x,y,z);


%% only do this to get spectrum scale
% z1f = ones(16,16);
% z1f(10,10) = 10;
[kx,ky,dummy] = grdfft (x,y,z1f);


%% calculate Cm, Thetam, Thetaf, M
Gamma = 6.67e-11;
si2mg = 1e5;
km2m=1e3;
Gamma = Gamma*si2mg*km2m;
%% This M could be a grid of varying magnetization
if length(M)~=1
    [xf,yf,M] = bigbord(x,y,M);
end
% M = ones(size(z1f)).*M;
% M = fftshift(fft2(M));

k = sqrt(kx.^2+ky.^2);
% note next term includes an upward continuation from z0 to z=0;
% Blakely (p294) doesn't have a minus sign here, but need it if convention
% is positive downwards
Const = 2*pi*Gamma.*exp(-k.*z0);


numtaylor = 1;
tol = 8;
NthSum = zeros(size(z1f));

while numtaylor<=tol
    
    %% Note that the term on the next line gets much bigger with each iteration,
    %% leading to instabilities if the number of iterations is too large +
    %% if topography is severe
    zf = ((z1f.^numtaylor) - (z2f.^numtaylor)).*M;
%     zf = (z1f.^numtaylor).*M;
%     [xf,yf,zf] = gridfill_new(x,y,z);
    [kx,ky,Zsp] = grdfft (x,y,zf);
    Nthterm = (((-k).^(numtaylor-1))./factorial(numtaylor)) .* (Zsp);
    
   
    NthSum = NthSum + (Const.*Nthterm);
    
%     disp(['finished iteration ',num2str(numtaylor),' ....'])
    numtaylor = numtaylor+1;
    
end


t = real(ifft2(ifftshift(NthSum)));
t = grdmask(x,y,z1,xf,yf,t);

% figure
% imagesc(x,y,-result);
% axis equal tight xy
% caxis([0 35000])
% colorbar
% hold on
% contour(X,Y,ZMoho,[5000:5000:20000],'k')
% plot([X(1) X(end)],[Y(150) Y(150)],'w-','linewidth',2)
% title('Moho Depth')

    
    
    

