function [rhoS] = DepthDependentDensity(z,phi0,c,RHOsg,RHOw);
% [rhoS] = DepthDependentDensity(z,phi0,c,RHOsg,RHOw);
%    RHOsg and RHOw are optional
%    units must be metres and kg/m3
%    see eg Sawyer (1985)

if ~exist('RHOsg')
    RHOsg = 2650; %this value is from Sawyer (1985) and lots of other papers also took this value
end
if ~exist('RHOw')
    RHOw = 1030;
end

rhoS = ((phi0.*exp(-c.*z)).*RHOw) + ( (1- (phi0.*exp(-c.*z)) ) .*RHOsg);


